/******************************************/ 
/* Carbon-compatible section of OroborOSX */
/* (c) Adrian Umpleby Jan 2002            */
/*                                        */
/* Original oroborus window manager code  */
/* (c) Ken Lynch Jan 2001                 */
/*                                        */
/* This file started life as main.c from  */
/* Apple's prototype Carbon application   */
/*                                        */
/* Distributed under the GPL              */ 
/* See LICENSE for more details           */ 
/******************************************/ 
 
/* main.c */

#include "main.h"
#include "communication.h"
#include "hackcmds.h"

OSXWinInfo	*group_list=NULL;
int		group_count=0, gIncludeOffScreen=0, gGotCVDHidden=0; 
WindowRef	lastFrontWin=NULL, noFocusWin=NULL, aboutWin=NULL;
WindowRef	waiting1Win=NULL, waiting2Win=NULL, passwordWin=NULL, alertWin=NULL, textInputWin=NULL;
char		*Display_Name=NULL, *xpidstr=NULL, *xverstr=NULL, *gThemeDir=NULL, *gKeymapName=NULL;
char		realPath[512], myPath[512], randomID[20];
// No longer needed, since these items have now been replaced by items in "Launch Menu Items" folder
//int		launch_count_xterm=1, launch_count_xedit=1, launch_count_xcalc=1;
//int		launch_count_xclock=1, launch_count_xbiff=1, launch_count_xeyes=1;
int 		realPathLen, myPathLen, gQuitFlag=0, reReadOnNextFront=0, gInited=0, gMinMethod=0;
int		gX11InFront=0, on_cmd_line=0, showingAboutWin=0, showingNoFocusWin=0;
int		shrinking_iconbars=1, gInterleaving_Windows=0, gMenubarSpace=0, gUseShapedTheme=0;
int		gBGWinSetting=BGWIN_NOTHING, cycleOff=0, can_send_hackcmds=0, inhibiting_info=1;
int		mouse_mode=MOUSE_NORMAL, real_x, real_y, lastrl_x=0, lastrl_y=0, groupCycleOff=0;
int		gHiding_Iconbars=1, iconbarpos=ICONBARPOS_TOPLEFT, iconbar_screen=0, gKeymapGlobal=1;
int		diffscrn_x=0, diffscrn_y=0, gInvisible=0, gX11MouseStuck=0, gotControlEvent=0;
int		lastchk_x=0, lastchk_y=0, lastchk_cnt=0, lastx11_x=0, lastx11_y=0, gQuietStartup=0;
int		oosxWasInFront=0, gVerboseConsole=0, showingAlert=0, launched_xdarwin=0;
long		lastBackTicks, lastIconbarOutTicks=0, lastOKTicks=0;
long		lastMovedTicks=0, lastCompareTicks=0;
Boolean		forceOOSXInFront=FALSE, xdarwin_is_stopped=FALSE;
ProcessSerialNumber	xPSN, myPSN;
extern int	iconbar_steps;

void Initialize(void);
void ShowOroborOSXHelp(void);
void ShowGeneralFile(char *name);
int CheckForX(void);
void LaunchX_GetPID(int launchit);
void Bring_To_Front(int quick);
void Bring_X_To_Front(int quick);
void Bring_OOSX_To_Front(void);
void Stop_XDarwin();
void Restart_XDarwin();
void InitPrefs();
void SavePrefs();

char *Escape_Quotes(char *instr, int which)
{
    int 	i,j=0,l;
    char	*retstr=NULL;
    
    if(instr==NULL) return NULL;
        
    l = strlen(instr);
    
    for(i=0;i<l;i++)
    	if(instr[i]==39) j++; 

#ifdef DEBUG
    printf("Received %s in Escape_Quotes (found %d quotes)\n",instr,j);
#endif
 
    if(which<l+j*3) {
    	retstr=malloc(l+j*3+5);
        if(retstr) {
            j=0;
            for(i=0;i<l;i++) {
                retstr[j]=instr[i];
                j++;
                if(instr[i]==39) {
                    retstr[j]=92;
                    retstr[j+1]=39;
                    retstr[j+2]=39;
                    j+=3;
                }
            }
            retstr[j]=0;
        }
#ifdef DEBUG
        printf("Returned %s (new) from Escape_Quotes\n",retstr);
#endif
    } else {
        j=l+j*3;
        for(i=l;i>=0;i--) {
            if(j<=0) {
#ifdef SHOW_WEIRD
                if(i!=0 || j!=0)
                    printf("Eh??? %d %d %d %s\n",j,i,l,instr);
#ifdef DEBUG
                else
                    printf("Got to end of string OK!\n");
#endif
#endif
                break;
            }
            instr[j]=instr[i];
            j--;
            if(instr[i]==39) {
                instr[j]=39;
                instr[j-1]=92;
                instr[j-2]=39;
                j-=3;
            }
        }
#ifdef DEBUG
        printf("Returned %s (same) from Escape_Quotes\n",instr);
#endif
    }
    
    return retstr;
}

/* Glue routine to find the button state from X11 section of code */
int Carbon_Button(void)
{
    if( Button() ) return 1;
    return 0;
}

/* Glue routine to get TickCount from X11 section of code */
long GetCarbonTickCount(void)
{
    return TickCount();
}

int check_for_keepalive()
{
    char buf[20], str[100];
    int i, sret, rcvlen;

        keepalive_socket = 0;
        
        if(can_send_hackcmds!=0 && main_socket!=0) {
                    
            i=0;
            sret=0;
            
            while(i<150 && sret==0) {
                if(CheckForX()==0) {
                    printf("%s: Lost XDarwin while waiting for keepalive\n",PROGNAME);
                    return -2;
                }
                sret=check_listen_accept_name(main_socket,str);
                if(sret==0) {
                    i++;
                    if(i==150) {
                        fprintf(stderr,"%s: keepalive did not register. Aborting.\n",PROGNAME);
                        return -1;
                    }
                    printf("%s Info: keepalive has not registered...\n",PROGNAME);
                    return 1;
//                    sleep(1);
                } else if(sret>0) {
                    printf("%s info: Server heard from socket client: %s\n",PROGNAME,str);
                    if(strlen(str)==9) {
                        if(strncasecmp(str,"keepalive",9)==0) {
                            keepalive_socket=sret;
                            printf("%s info: Set keepalive_socket=%d\n",PROGNAME,keepalive_socket);
                            return 0;
                        } else
                            sret = 0;
                    } else
                        sret = 0;
                }
            }
		
            if( sret < 0 ) {
                fprintf(stderr,"%s: Got an error from check_listen_accept_name: %d\n",PROGNAME,sret);
                return -1;
            }
        }
        
        return 0;
}

char *wait_for_display_string()
{
    char *dispstr=NULL;
    char buf[20], str[100];
    int i, sret, rcvlen;

        keepalive_socket = 0;
        
        if(can_send_hackcmds!=0 && main_socket!=0) {
                    
            i=0;
            sret=0;
            
            while(i<150 && sret==0) {
                if(CheckForX()==0) {
                    printf("%s: Lost XDarwin while waiting for keepalive\n",PROGNAME);
                    return NULL;
                }
                sret=check_listen_accept_name(main_socket,str);
                if(sret==0) {
                    i++;
                    if(i==150) {
                        fprintf(stderr,"%s: keepalive did not register. Aborting.\n",PROGNAME);
                        return NULL;
                    }
                    printf("%s Info: Waiting for keepalive to register...\n",PROGNAME);
                    sleep(1);
                } else if(sret>0) {
                    printf("%s info: Server heard from socket client: %s\n",PROGNAME,str);
                    if(strlen(str)==9) {
                        if(strncasecmp(str,"keepalive",9)==0) {
                            keepalive_socket=sret;
                            printf("%s info: Set keepalive_socket=%d\n",PROGNAME,keepalive_socket);
                        } else
                            sret = 0;
                    } else
                        sret = 0;
                }
            }
		
            if( sret < 0 ) {
                fprintf(stderr,"%s: Got an error from check_listen_accept_name: %d\n",PROGNAME,sret);
                return NULL;
            }
            
            i = 0;
            while(i<10) {
                if(CheckForX()==0) {
                    printf("%s: Lost XDarwin while waiting for DISPLAY\n",PROGNAME);
                    return NULL;
                }
                rcvlen = check_listen_get_bytes(keepalive_socket,buf);
                if(rcvlen==0) {
                    printf("Got zero from keepalive...\n");
                    return NULL;
                } else if(rcvlen==-2) {
                    printf("keepalive ended session.\n");
                    return NULL;
                } else if(rcvlen==-1) {
                    // nothing in receive buffer
                    sleep(1);
                    i++;
                    if(i==10) {
                        fprintf(stderr,"%s: keepalive did not send DISPLAY. Aborting.\n",PROGNAME);
                        return NULL;
                    }
                    printf("%s Info: Waiting for keepalive to send DISPLAY...\n",PROGNAME);
                } else if(rcvlen<0) {
                    printf("Got an error from check_listen_get_bytes: %d\n",rcvlen);
                    return NULL;
                } else {
                    printf("Received DISPLAY from keepalive: %s\n",buf);
                    dispstr = strdup(buf);
                    Allow_HUPs(0);
                    return dispstr;
                }
            }
        }
/*
// open the file created by orobxinitrc
    i=0;
    sprintf(script,"/tmp/oroborosx-%s.dir/display",randomID);
    while(i<180 && dispstr==NULL) {
        if((file=fopen(script, "r")))  {
// and extract the display string from it
            if(fgets(buf, sizeof buf, file)) {
                dispstr=strdup(buf);
                i=strlen(dispstr);
                if(dispstr[i-1]<32) dispstr[i-1]=0;
                printf("%s info: got '%s' from %s\n",PROGNAME,dispstr,script);
            } else {
                printf("%s: failed to read from %s\n",PROGNAME,script);
                if(i<179) {
                    i=179;
                    sleep(1);	// allow one more try, just in case it did not have time to write the line
                } else
                    i=200;	// give up
            }
            fclose(file);
        } else {
            i++;
            if(CheckForX()==0) {
                printf("%s: Lost XDarwin while waiting for display\n",PROGNAME);
                return NULL;
            }
            if(i<180) {
                printf("%s info: waiting for %s\n",PROGNAME,script);
                sleep(1);
            } else
                printf("%s: failed to open file %s\n",PROGNAME,script);
        }
    }
    
    sprintf(script,"/bin/rm -f /tmp/oroborosx-%s.dir/display",randomID);
    system(script);
*/
    
    return dispstr;
}

int main2(int argc, char *argv[])
{
        int retval, i, dummy;
        char *dpy_str=NULL;

//        ShowAlert("Test",0,0);
        waiting1Win=NULL;
        waiting2Win=NULL;
        if(gQuietStartup==0) waiting1Win=MakeWindow(waiting1Wintype);

// Check to see if XDarwin is already running
        printf("%s info: checking for XDarwin\n",PROGNAME);
        if(CheckForX()==0) {
// Try to launch it if not
            if(gQuietStartup==0) waiting2Win=MakeWindow(waiting2Wintype);
            if(waiting1Win) DisposeWindow(waiting1Win);
            waiting1Win=waiting2Win;
            waiting2Win=NULL;
            LaunchX_GetPID(1);
            init_rules_list();
            retval=-1;
            if(gQuitFlag==0) {
// Get the DISPLAY variable from XDarwin (via the xinitrc file)
                dpy_str=wait_for_display_string();
                if(dpy_str==NULL) retval = -4;
                //dpy_str=malloc(10);
                //sprintf(dpy_str,":0.0");
                i=0;
                while(retval==-1 && i<10) {
// See if the window manager can find the display yet
                    if(gQuietStartup==0) waiting2Win=MakeWindow(waiting3Wintype);
                    if(waiting1Win) DisposeWindow(waiting1Win);
                    waiting1Win=waiting2Win;
                    waiting2Win=NULL;
                    Restart_XDarwin();
                    retval=orob_main(argc,argv,dpy_str);
                    if(retval==-1) {
                        if(CheckForX()==0) {
                            printf("%s warning: XDarwin has vanished!\n",PROGNAME);
                            return -1;
                        }
                        printf("%s info: Waiting for XDarwin to be ready... %d\n",PROGNAME,retval);
                        dummy=sleep(1);
                        //system("/bin/sleep 2");
                        i++;
                    }
                }
                if(retval!=0 && gQuitFlag==0) {
                    fprintf(stderr,"%s: XDarwin has not initialised correctly (%d). Aborting.\n",PROGNAME,retval);
                    ShowAlert(XDARWINFAIL_NAME,0,3);
                    gQuitFlag=XDARWINFAIL_ERRNO;
                } else if(gQuitFlag==0) {
                    char *script=NULL;
                    script = malloc(35+strlen(dpy_str));
                    if(script) {
                        sprintf(script,"Contents/Scripts/SetXPrefs '%s'",dpy_str);
                        system(script);
                        free(script);
                    }
                }
            }
            if(retval==0)
                printf("%s info: XDarwin is ready...\n",PROGNAME);
        } else {
            SetupMenus();
// Just get the PID for XDarwin
            LaunchX_GetPID(0);
            init_rules_list();
            if(gQuietStartup==0) waiting2Win=MakeWindow(waiting3Wintype);
            if(waiting1Win) DisposeWindow(waiting1Win);
            waiting1Win=waiting2Win;
            waiting2Win=NULL;
            Restart_XDarwin();
            retval=orob_main(argc,argv,NULL);
            if(retval!=0 && gQuitFlag==0) {
                dummy=sleep(2);
                if(CheckForX()==0) {
                    printf("%s warning: lost XDarwin -will try launching again...\n",PROGNAME);
                    retval=10203;
                }
            }
        }
        if(waiting1Win) DisposeWindow(waiting1Win);
        if( retval==0 ) {
            EventLoop();
        } else {
            fprintf(stderr,"%s: Got an error from orob_main: %d\n",PROGNAME,retval);
        }
        
	return retval;
}

/*
 * Check to see if there are internal archives that need expanding
 */
void CheckForArchives()
{
    char	script[50];
    int		err;
    
    sprintf(script,"Contents/Scripts/CheckForArchives");
    err=system(script);
    if(err) {
        fprintf(stderr,"%s: got error %d from CheckForArchives script!\n",PROGNAME,err);
        gQuitFlag=-1004;
    } else
        printf("%s info: come back from CheckForArchives script\n",PROGNAME);
}

int main(int argc, char *argv[])
{
    int retval=0;
    
    sprintf(lastsub,"TRACE1: main (argc: %d)\n",argc);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: main (argc: %d)\n",argc);
#endif

    Initialize();
    
    printf("%s info: About to enter CheckForArchives? (gQuitFlag=%d)\n",PROGNAME,gQuitFlag);
    if(gQuitFlag==0) CheckForArchives();

    printf("%s info: About to enter MakeMenu? (gQuitFlag=%d)\n",PROGNAME,gQuitFlag);
    // Grab the Menu bar from the nib package
    if(gQuitFlag==0) MakeMenu();
    
    printf("%s info: About to enter MakeWindow? (gQuitFlag=%d)\n",PROGNAME,gQuitFlag);
    // Create the special window for the 'all iconbars/all icons' case, and the 'no clients' case
    if(gQuitFlag==0) noFocusWin=MakeWindow(noFocusWintype);

    printf("%s info: About to enter main2? (gQuitFlag=%d)\n",PROGNAME,gQuitFlag);
    // try to run...
    if(gQuitFlag==0) retval=main2(argc,argv);
    
    if(retval==10203 && gQuitFlag==0) printf("%s info: About to enter main2 again (gQuitFlag=%d)\n",PROGNAME,gQuitFlag);
    // try again if it found XDarwin was there to start with, then vanished...
    if(retval==10203 && gQuitFlag==0) retval=main2(argc,argv);

    printf("%s: finishing with gQuitFlag=%d\n",PROGNAME,gQuitFlag);
    ClearUpSockets();
    return 0;
}

int SetMyPath()
{
    CFURLRef	myURL;
    CFBundleRef mainBundle;
    int		i;
    
    sprintf(lastsub,"TRACE2: SetMyPath\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: SetMyPath\n");
#endif

// Get the main bundle for the app, and find the path
    realPathLen=512;
    mainBundle = CFBundleGetMainBundle();
    myURL=CFBundleCopyBundleURL(mainBundle);
    CFURLGetFileSystemRepresentation(myURL,TRUE,realPath,realPathLen);
    
// Now search for single quotes, replacing them with '\'' to create the path used for
// starting scripts. The real path is also kept so that the config file can be read.
    realPathLen=strlen(realPath);
    myPathLen=0;
    for(i=0;i<=realPathLen;i++) {
        myPath[myPathLen]=realPath[i];
        myPathLen++;
        if(realPath[i]==39) {
            if(myPathLen>508) {
                fprintf(stderr,"%s: Path name too long! %s\n",PROGNAME,myPath);
                return -1; }
            myPath[myPathLen]=92;
            myPathLen++;
            myPath[myPathLen]=39;
            myPathLen++;
            myPath[myPathLen]=39;
            myPathLen++;
        }
    }
    printf("%s info: myPathLen,realPathLen: %d,%d\n",PROGNAME,myPathLen,realPathLen);
    printf("%s info: myPath: %s\n",PROGNAME,myPath);
    myPath[myPathLen]=0;
    myPathLen=strlen(myPath);
    i=chdir(realPath);
    system("echo -n 'chdir: ';pwd");
    return i;
}

void ClearUpSockets()
{
    char *socket_path=NULL;

    if(xdarwin_socket) close(xdarwin_socket);
    if(keepalive_socket) {
        Allow_HUPs(-1);
        close(keepalive_socket);
    }
    
    socket_path = malloc(strlen(MAIN_SOCKET_PATH)+strlen(randomID)+5);
    sprintf(socket_path,"%s.%s",MAIN_SOCKET_PATH,randomID);
    if(main_socket) end_listen_socket(main_socket,socket_path);
    free(socket_path);
    main_socket=0;
    xdarwin_socket=0;
    keepalive_socket=0;
}

void Initialize()	/* Initialize some things */
{
    OSErr		err;
    char		*socket_path;
    
    sprintf(lastsub,"TRACE1: Initialize\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: Initialize\n");
#endif

// Make a unique (probably!) ID for this process to create temporary files
    srandom(TickCount());
    sprintf(randomID,"%#lx",random());
    err = setenv("OROBOROSX_RANDOMID",randomID,1);
    printf("%s Info: Set OROBOROSX_RANDOMID to %s (%d)\n",PROGNAME,randomID,err);

// make sure we don't get HUPs
    Allow_HUPs(0);

    socket_path = malloc(strlen(MAIN_SOCKET_PATH)+strlen(randomID)+5);
    sprintf(socket_path,"%s.%s",MAIN_SOCKET_PATH,randomID);

    main_socket=init_listen_socket(socket_path);
    
    free(socket_path);
    
// Cursor manager    
    InitCursor();
    
// Make sure path to OroborOSX is set up
    SetMyPath();

// Get the PSN for OroborOSX
    err = GetCurrentProcess(&myPSN);

    InitAEHandlers();
    
    {
        int x = 0;
        int y = 0;
        Cocoa_To_Carbon(&x,&y);
    }
    printf("%s info: Found main screen: %#lx  (%d,%d,%d,%d)\n",PROGNAME,gMainScreen,gMainRect.left,gMainRect.top,gMainRect.right,gMainRect.bottom);

    InitPrefs();

}

int CheckForX()
{
    ProcessInfoRec	procInfo;
    ProcessSerialNumber aPSN;
    short		myErr;
    pstr_t		procName;
    
    sprintf(lastsub,"TRACE1: CheckForX\n");
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: CheckForX\n");
#endif

    aPSN.highLongOfPSN=0;
    aPSN.lowLongOfPSN=0;

    myErr=noErr;

// Go through list of applications, looking for XDarwin
    while(myErr==noErr) {
    
        myErr=GetNextProcess(&aPSN);
    
        if(myErr==noErr) {
            procInfo.processName=(char *) &procName;
            procInfo.processAppSpec=NULL;
            myErr=GetProcessInformation(&aPSN,&procInfo);
        } else if(myErr==-600 || myErr==-50)
            myErr=-1000;
        
        if(myErr==-50)
            myErr=noErr;
        else if(myErr==noErr) {
            if(strncasecmp(procName.thestr,XDARWIN_NAME,XDARWIN_NAMELEN)==0 ||
               strncasecmp(procName.thestr,ALT_XDW_NAME,ALT_XDW_NAMELEN)==0) {
// Found XDarwin!
                xPSN=aPSN;
                return 1;
            }
        }
    }
    
    return 0;
}

void LaunchX_GetPID(int launchit)
{
    char *script=NULL, *lvalue=NULL;
    char buf[20];
    int i, dummy;
    FILE *file;

    sprintf(lastsub,"TRACE1: LaunchX_GetPID (launchit: %d)\n",launchit);
    subtrace();
#ifdef SHOW_TRACE1
    printf("TRACE1: LaunchX_GetPID (launchit: %d)\n",launchit);
#endif

#ifdef DEBUG    
    printf("About to malloc script: 40\n");
#endif
    script=malloc(40);
#ifdef DEBUG    
    printf("script: %#lx\n",(long) script);
#endif

    launched_xdarwin=0;
    diffscrn_x=0;
    diffscrn_y=GetMBarHeight()-1;
    printf("%s info: Started with screen offset: %d,%d\n",PROGNAME,diffscrn_x,diffscrn_y);
    
    if(script==NULL)
    {
        if(on_cmd_line) {
            fprintf(stderr, "%s: Memory allocation failed in LaunchX_GetPID.\n", PROGNAME);
            ClearUpSockets();
            exit(1);
        } else {
            fprintf(stderr, "%s: Memory allocation failed in LaunchX_GetPID.\n", PROGNAME);
            ShowAlert(FATALMEM_NAME,0,0);
            gQuitFlag=FATALMEM_ERRNO;
            return;
        }
    }
    
    if(launchit!=0) {
        sprintf(script,"Contents/Scripts/startx");
        printf("%s info: X11 startup script: %s\n",PROGNAME,script);
  
// run script to start up X11...
        if(system(script)!=0) {
            ShowAlert(STARTXFAIL_NAME,0,3);
            gQuitFlag=STARTXFAIL_ERRNO;
            free(script);
            return;
        }
//    system("PATH=.:/usr/bin:/bin:/usr/X11R6/bin:/usr/local/bin:~/bin;startx -- -rootless &");

// do something useful while we're waiting...
        SetupMenus();
        
// Not very Mac-ish way to wait for something...!
        i=0;
        while(CheckForX()==0 && i<15) {
            printf("%s info: waiting for XDarwin to start...\n",PROGNAME);
            dummy=sleep(1);
            //system("/bin/sleep 2");
            i++;
        }
    
        if(i==15) {
            free(script);
            fprintf(stderr,"%s: failed to start XDarwin\n",PROGNAME);
            ShowAlert(NOXDARWIN_NAME,0,3);
            gQuitFlag=NOXDARWIN_ERRNO;
            return;
        }
// wait a second to make sure everything has calmed down...
        dummy=sleep(1);
        launched_xdarwin=1;
        //system("/bin/sleep 2");
    }

// use the random string as part of the PID filename
    sprintf(script,"Contents/Scripts/GetXpid %s",randomID);
    printf("%s info: Getting XDarwin info: %s\n",PROGNAME,script);
// run script which finds the PID and version of XDarwin...
    system(script);
        
// Now open the file (/tmp/XDarwin-pid.'$randomID')
    can_send_hackcmds = 0;
    sprintf(script,"/tmp/XDarwin-pid.%s",randomID);
    if((file=fopen(script, "r"))) 
    {
// and extract the PID from it
        if(fgets(buf, sizeof buf, file)) 
        { 
            lvalue=strtok(buf, "\n"); 
            if(lvalue)
                xpidstr=strdup(lvalue);
            else
                xpidstr=strdup(buf);
            printf("%s info: Got XDarwin PID: %s\n",PROGNAME,xpidstr);
        } 
// and extract the version from it
        if(fgets(buf, sizeof buf, file)) 
        { 
            lvalue=strtok(buf, "\n"); 
            if(lvalue)
                xverstr=strdup(lvalue);
            else
                xverstr=strdup(buf);
            printf("%s info: Got XDarwin version: %s\n",PROGNAME,xverstr);
        } else {
            printf("%s warning: Failed to get version for XDarwin...\n",PROGNAME);
            xverstr=strdup("?????");
            ShowAlert(XDARWINVER_NAME,0,0);
        }
// and extract the interleave & hackcmd state from it
        if(fgets(buf, sizeof buf, file)) 
        { 
            if(!strncasecmp(buf,"interleave: ",12)) {
                if(!strncasecmp(buf,"interleave: 0",13))
                    gInterleaving_Windows=0;
                else
                    gInterleaving_Windows=1;
                printf("%s info: Got interleave state: %d\n",PROGNAME,gInterleaving_Windows);
                if(fgets(buf, sizeof buf, file)) {
                    if(!strncasecmp(buf,"hackenabled: 0",14)) {
                        can_send_hackcmds=0;
                        ShowAlert(HACKWARN_NAME,0,0);
                    } else
                        can_send_hackcmds=1;
                    printf("%s info: Got hackcmd state: %d\n",PROGNAME,can_send_hackcmds);
                } else {
                    printf("%s warning: hackcmd state not found in file\n",PROGNAME);
                    ShowAlert(HACKREAD_NAME,0,0);
                }
                Setup_Options_Menu(0);
            } else {
                printf("%s warning: Failed to get interleave state: %s\n",PROGNAME,buf);
                ShowAlert(INTLVREAD_NAME,0,0);
            }
        } else {
            printf("%s warning: interleave & hackcmd state not found in file\n",PROGNAME);
            gInterleaving_Windows=0;
            can_send_hackcmds=0;
            ShowAlert(INTLVREAD_NAME,0,0);
            ShowAlert(HACKREAD_NAME,0,0);
            Setup_Options_Menu(0);
        }
        fclose(file);
// and get rid of the file
        sprintf(script,"/bin/rm -f /tmp/XDarwin-pid.%s",randomID);
        printf("%s info: Removing file: %s\n",PROGNAME,script);
        system(script);
// now check which version we got and change various things appropriately
//        gUseShapedTheme=1;
        if(!strncmp(xverstr,"*****",5))
            ;
//            gUseShapedTheme=1;
        else if(!strncasecmp(xverstr,"1.0a3",5))
            gUseShapedTheme=0;
        else if(!strncasecmp(xverstr,"1.0a2",5))
            gUseShapedTheme=0;
        else if(!strncasecmp(xverstr,"1.0a1",5)) {
            gUseShapedTheme=0;
            gMenubarSpace=1;
            diffscrn_y=0;
            printf("%s info: Resetting screen offset: 0,0\n",PROGNAME);
        }
        Setup_Themes_Menu(0);
        setenv("XDARWIN_VERSION",xverstr,1);
    } else {
        printf("%s warning: pid file not found (%s)\n",PROGNAME,script);
        can_send_hackcmds = 0;
        gInterleaving_Windows=0;
        ShowAlert(XDARWINVER_NAME,0,0);
        ShowAlert(INTLVREAD_NAME,0,0);
        ShowAlert(HACKREAD_NAME,0,0);
        Setup_Options_Menu(0);
    }
// wait a second to make sure everything has calmed down...
    dummy=sleep(1);
    //system("/bin/sleep 1");
    
    // Now that we're sure we can send hack commands to XDarwin, and that its plist has the right
    // setting in it, interleaving can be toggled easily, so get the setting from the prefs file
    if(can_send_hackcmds && gInterleaving_Windows)
        gInterleaving_Windows=getIntPref(kPrefInterleavingWindows,1);
    
#ifdef DEBUG
    printf("About to free script in LaunchX_GetPID...\n");
#endif
    free(script);
#ifdef DEBUG
    printf("script freed OK\n");
#endif
}

void Restart_XDarwin()
{
    char	script[25];
    
#ifndef STOPSTART
    return;
#endif
    if(!xpidstr) return;
    
    printf("%s is CHECKING XDARWIN status: %d\n",PROGNAME,xdarwin_is_stopped==FALSE?0:1);
    if(xdarwin_is_stopped) {
        sprintf(script,"kill -CONT %s",xpidstr);
        printf("%s is CONTINUING XDARWIN: %s\n",PROGNAME,script);
        system(script);
        xdarwin_is_stopped=FALSE;
    }
}

void Stop_XDarwin()
{
    char	script[25];
    
#ifndef STOPSTART
    return;
#endif
    if(!xpidstr) return;
    
    printf("%s is CHECKING XDARWIN: %d\n",PROGNAME,xdarwin_is_stopped==FALSE?0:1);
    if(!xdarwin_is_stopped) {
        sprintf(script,"kill -STOP %s",xpidstr);
        printf("%s is STOPPING XDARWIN: %s\n",PROGNAME,script);
        system(script);
        xdarwin_is_stopped=TRUE;
    }
}

void Bring_To_Front(int quick)	/* when an X11 window is clicked, bring everything in front */
{
    OSErr		myErr;
    Boolean		same, wassame;
    ProcessSerialNumber	frontPSN;
    int			i;
    
    sprintf(lastsub,"TRACE2: Bring_To_Front\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: Bring_To_Front\n");
#endif

    if( keepInFrontUntil!=-1 || mouse_mode!=-1 || alertWin!=NULL ) {

    myErr=GetFrontProcess(&frontPSN);
    myErr=SameProcess(&frontPSN,&myPSN,&wassame);

//    show_last_fifteen();
    myErr=SetFrontProcess(&myPSN);
    
    same=FALSE;
    i = 0;
    while(!same) {
        i++;
        if(i>200) {
#ifdef SHOW_WEIRD
            printf("%s warning: Failed to come in front for 1.5 sec!\n",PROGNAME);
#endif
            same=TRUE;
            break;
        }
        usleep(3000);
        myErr=GetFrontProcess(&frontPSN);
        if(myErr==noErr)
            myErr=SameProcess(&frontPSN,&myPSN,&same);
        if(myErr!=noErr) {
#ifdef SHOW_WEIRD
            printf("%s warning: Got an error trying to check if OOSX is in front?!\n",PROGNAME);
#endif
            same=TRUE;
            forceOOSXInFront=TRUE;
        }
    }

    oosxWasInFront=1;
//    printf("Forced OroborOSX in front\n");
    
    if(alertWin!=NULL) {
        ShowWindow(alertWin);
        SelectWindow(alertWin);
        return;
    }
    
    if(can_send_hackcmds && gInterleaving_Windows==0) {
        raise_all_clients();
        gX11InFront=1;
        return;
    }

    }
    
    // need to wait a little for the Dock to disappear in whole screen mode...
    if( keepInFrontUntil==-1 && mouse_mode==0 ) {
        printf("Bring_To_Front: Not bringing X in front because of keepInFrontUntil...\n");
    } else {

    SendSimpleHackCommand(HACKCMD_COMEINFRONT,1);
//    myErr=SetFrontProcess(&xPSN);

    same=FALSE;
    i = 0;
    while(!same) {
        i++;
        if(i>500) {
#ifdef SHOW_WEIRD
            printf("%s warning: Failed to bring XDarwin in front for 1.5 sec!\n",PROGNAME);
#endif
            same=TRUE;
            break;
        }
        usleep(3000);
        myErr=GetFrontProcess(&frontPSN);
        if(myErr==noErr)
            myErr=SameProcess(&frontPSN,&xPSN,&same);
        if(myErr!=noErr) {
#ifdef SHOW_WEIRD
            printf("%s warning: Got an error (%d) trying to check if XDarwin is in front?!\n",
                                                                                PROGNAME,myErr);
#endif
            same=TRUE;
        }
    }
    
#ifdef DEBUG
    printf("XDarwin has been forced to front\n");
#endif
    }
    
/*    if(stopx!=0) {
        Stop_XDarwin();
        dummy=sleep(1);
        //system("/bin/sleep 1");
        Restart_XDarwin();
    }*/

    if(gX11InFront==0 && quick==0) {
        gX11InFront=1;
        come_to_front();
    }
// Also set a flag so that OroborOSX will be forced in front briefly (in DoIdle),
// so that its menubar will be visible...
//    forceOOSXInFront=TRUE;
}

void Bring_OOSX_To_Front()	/* bring OroborOSX in front */
{
    OSErr		myErr;
    
    sprintf(lastsub,"TRACE2: Bring_OOSX_To_Front\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: Bring_OOSX_To_Front\n");
#endif

//    show_last_fifteen();
    myErr=SetFrontProcess(&myPSN);
//    myErr=SetFrontProcess(&xPSN);
//    gX11InFront=1;

}

void Bring_X_To_Front(int quick)	/* bring XDarwin in front */
{
    OSErr		myErr;
    
    sprintf(lastsub,"TRACE2: Bring_X_To_Front\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: Bring_X_To_Front\n");
#endif

    if(alertWin!=NULL) {
        myErr=SetFrontProcess(&myPSN);
        ShowWindow(alertWin);
        SelectWindow(alertWin);
        return;
    }

    // need to wait a little for the Dock to disappear in whole screen mode...
    /*if( keepInFrontUntil==-1 && mouse_mode==0 ) {
        printf("Bring_X_To_Front: Not bringing X in front because of keepInFrontUntil...\n");
        return;
    }*/

//    show_last_fifteen();
//    myErr=SetFrontProcess(&myPSN);
    if(can_send_hackcmds && gInterleaving_Windows==0)
        raise_all_clients();
    else if( keepInFrontUntil==-1 && mouse_mode==0 )
        printf("Bring_X_To_Front: Not bringing X in front because of keepInFrontUntil...\n");
    else
        SendSimpleHackCommand(HACKCMD_COMEINFRONT,1);
//        myErr=SetFrontProcess(&xPSN);
#ifdef DEBUG
    printf("XDarwin has been forced to front\n");
#endif
    if(gX11InFront==0 && quick==0) {
        gX11InFront=1;
        come_to_front();
    }
}

void will_hide_all_iconbars()
{
    if(gHiding_Iconbars==0) return;
    sprintf(lastsub,"TRACE2: will_hide_all_iconbars (lastIconbarOutTicks: %d)\n",lastIconbarOutTicks);
    subtrace();
    lastIconbarOutTicks=TickCount();
#ifdef SHOW_TRACE2
    printf("TRACE2: will_hide_all_iconbars (lastIconbarOutTicks: %d)\n",lastIconbarOutTicks);
#endif
}

void Compare_Screens(int scrnx, int scrny, int x11x, int x11y, int allowset)
{
    Point	mspt;
    long	nowTicks, notMovedTicks, notCompareTicks;
    int		moving;

// Should never compare when behind, since XDarwin does not track the cursor
    if(gX11InFront==0) return;
    
// once we have a high enough confidence, don't check any more...
//    if(lastchk_cnt>1) return;

    sprintf(lastsub,"TRACE3: Compare_Screens\n");
    subtrace();
#ifdef SHOW_TRACE3
    printf("TRACE3: Compare_Screens\n");
#endif

// Work out what we *think* the X11 co-ords should be...
    GetGlobalMouse(&mspt);
    real_x=mspt.h-diffscrn_x;
    real_y=mspt.v-diffscrn_y;
    
// Hmmmm... XDarwin reports funny co-ords once we get inside the menu bar, so ignore
// points near there
    if(mspt.v>-4 && mspt.v<25 && mspt.h>0) return;

    moving=0;
    if(real_x!=scrnx)
        moving=1;
    else if(real_y!=scrny)
        moving=1;
        
//    printf("Mouse co-ords: %d,%d  %d,%d  %d,%d\n",real_x,real_y,scrnx,scrny,x11x,x11y);
//    if(allowset!=0 && gX11MouseStuck!=0) {
//        gX11MouseStuck=0;
//        printf("X11 cursor unstuck with allowset...\n");
//    }
    
    nowTicks=TickCount();
    
    if(moving!=0) {
#ifdef SHOW_MOUSE
        printf("Mouse moved: %d,%d  (from %d,%d)\n",real_x,real_y,lastrl_x,lastrl_y);
#endif
        lastMovedTicks=nowTicks;
        lastrl_x=real_x;
        lastrl_y=real_y;
        // use the x11 positions, since that's what x11 will work with for its enter/leave events
        real_x=x11x;
        real_y=x11y;
        return;
    }

    if(lastCompareTicks==0) {
        lastCompareTicks=nowTicks;
        return;
    }
    if(lastMovedTicks==0) {
        lastMovedTicks=nowTicks;
        return;
    }
    notMovedTicks=nowTicks-lastMovedTicks;
    notCompareTicks=nowTicks-lastCompareTicks;
    
// leave a gap of at least 2 ticks between each compare
    if(notCompareTicks<2) return;
// make a note of the time when we got here
    lastCompareTicks=nowTicks;

// and only compare if we have definitely been here before, since the cursor stopped moving...
    if(notCompareTicks*2>notMovedTicks) return;
    
// only compare if the cursor has been still for at least sixth of a second...
//    if(notMovedTicks<10) return;
// ...and if it is not in the same place it was at the last check...
//    if(lastchk_x==mspt.h && lastchk_y==mspt.v) return;
// ...and if the x11 pointer does not appear to have frozen
//    if(lastx11_x==x11x && lastx11_y==x11y) return;

    lastrl_x=x11x;
    lastrl_y=x11y;

    lastchk_y=mspt.v;
    lastchk_x=mspt.h;

    if(scrnx!=x11x || scrny!=x11y) {
        // is the x11 cursor stuck?
        if(lastx11_x==x11x && lastx11_y==x11y && allowset<2 && !Button() ) {
#ifdef SHOW_SCREENDIFF
            printf("%s info: X11 cursor stuck?  %d,%d  %d,%d  %d,%d\n",PROGNAME,mspt.h,mspt.v,scrnx,scrny,x11x,x11y);
#endif
            // Always unstick X11 cursor...
            force_ungrab();
            Bring_OOSX_To_Front();
            forceOOSXInFront=FALSE;
            return;
        }
        // make sure we have the last recorded x11 cursor position for future checking
        lastx11_x=x11x;
        lastx11_y=x11y;
        // Are we already confident of the difference, even though it has changed...?
        if(lastchk_cnt>1 && allowset<2) return;
        // start again with the confidence factor
        lastchk_cnt=0;
        // now reset the deltas...
        if(allowset!=0) {
            diffscrn_x += scrnx-x11x;
            diffscrn_y += scrny-x11y;
#ifdef SHOW_SCREENDIFF
            printf("%s info: New screen difference: deltax=%d, deltay=%d   ",PROGNAME,diffscrn_x,diffscrn_y);
            printf("  (reported coords: %d,%d  %d,%d  %d,%d)\n",mspt.h,mspt.v,scrnx,scrny,x11x,x11y);
#endif
        }
        // use the x11 positions, since that's what x11 will work with for its enter/leave events
        real_x=x11x;
        real_y=x11y;
    } else {
        // don't want to get it wrong if the x11 cursor is stuck
        if(lastx11_x==x11x && lastx11_y==x11y)
            return;
        // use the x11 positions, since that's what x11 will work with for its enter/leave events
        real_x=x11x;
        real_y=x11y;
        // make sure we have the last recorded x11 cursor position for future checking
        lastx11_x=x11x;
        lastx11_y=x11y;
        // don't go any further if we're already confident enough...
        if(lastchk_cnt>1 && allowset<2) return;
        // now reset the deltas...
        if(allowset!=0) {
            diffscrn_x += scrnx-x11x;
            diffscrn_y += scrny-x11y;
#ifdef SHOW_SCREENDIFF
            printf("%s info: Screen compare confidence: %d    deltax=%d, deltay=%d\n",PROGNAME,lastchk_cnt,diffscrn_x,diffscrn_y);
#endif
            // got the same as at the last check, so increment the confidence factor
            lastchk_cnt++;
        }
    }
}

void ShowGeneralFile(char *name)
{
    char	*script=NULL;
    
    sprintf(lastsub,"TRACE2: ShowGeneralFile %s\n",name);
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: ShowGeneralFile %s\n",name);
#endif

    script=malloc(25+strlen(name));
    if(script==NULL) {
        printf("%s warning: Failed to allocate memory for script in ShowGeneralFile: %s\n",PROGNAME,name);
        ShowAlert(WARNMEM_NAME,1,0);
        return;
    }

    sprintf(script,"open -a TextEdit.app %s",name);
    printf("%s info: running: %s\n",PROGNAME,script);
    system(script);
    
    // extra bit to make sure TextEdit comes in front
    sleep(1);
    sprintf(script,"open -a TextEdit.app");
    system(script);
    
    free(script);
}

void ShowAboutThisTheme()
{
    char	*script=NULL, *escThemeDir=NULL;
    int		err;
    
    escThemeDir=Escape_Quotes(gThemeDir,0);

    if(escThemeDir) {
      script=malloc(40+strlen(escThemeDir));
      sprintf(script,"Contents/Scripts/ThemeList 'info' '%s'",escThemeDir);
    } else {
      script=malloc(40+strlen(gThemeDir));
      sprintf(script,"Contents/Scripts/ThemeList 'info' '%s'",gThemeDir);
    }
    
    printf("%s info: Running: %s\n",PROGNAME,script);
// run script to show theme info...
    err=system(script);
    
    free(script);
    if(escThemeDir)
      free(escThemeDir);
    
    if(err==NOTHEMEFLDR_STAT)
        ShowAlert(NOTHEMEFLDR_NAME,1,0);
}

int ShowHelpFile(int which)
{
    CFURLRef	myURL;
    CFBundleRef mainBundle;
    int		i, helpPathLen, openstrlen;
    char	helpPath[512], openstr[10];
    
    sprintf(lastsub,"TRACE2: ShowHelpFile\n");
    subtrace();
#ifdef SHOW_TRACE2
    printf("TRACE2: ShowHelpFile\n");
#endif

// Get the main bundle for the app, and find the path
    helpPathLen=512;
    mainBundle = CFBundleGetMainBundle();

    if(which==README_FILEID)
        myURL=CFBundleCopyResourceURL(mainBundle,CFSTR("README"),CFSTR("rtf"),NULL);
    else if(which==THEMES_FILEID)
        myURL=CFBundleCopyResourceURL(mainBundle,CFSTR("THEMES"),CFSTR("rtf"),NULL);
    else if(which==LICENSE_FILEID)
        myURL=CFBundleCopyResourceURL(mainBundle,CFSTR("LICENSE"),CFSTR("rtf"),NULL);
    else if(which==HISTORY_FILEID)
        myURL=CFBundleCopyResourceURL(mainBundle,CFSTR("HISTORY"),CFSTR("rtf"),NULL);
    else if(which==LMI_FILEID)
        myURL=CFBundleCopyResourceURL(mainBundle,CFSTR("LMI"),CFSTR("rtf"),NULL);
    else if(which==HELPERS_FILEID)
        myURL=CFBundleCopyResourceURL(mainBundle,CFSTR("HELPERS"),CFSTR("rtf"),NULL);
    else if(which==RULES_FILEID)
        myURL=CFBundleCopyResourceURL(mainBundle,CFSTR("RULES"),CFSTR("rtf"),NULL);
    else
        return -1;
        
    CFURLGetFileSystemRepresentation(myURL,TRUE,helpPath,helpPathLen);
    helpPathLen=strlen(helpPath);
    sprintf(openstr,"open -a TextEdit.app ");
    openstrlen=strlen(openstr);
    
// Now check that the first realPathLen characters are the same as the path for the bundle 
    if(helpPathLen<=realPathLen) {
        printf("%s warning: file path is shorter than main bundle: %s\n",PROGNAME,helpPath);
    } else if(strncasecmp(helpPath,realPath,realPathLen)) {
        printf("%s warning: file path is not in main bundle: %s\n",PROGNAME,helpPath);
    } else {
        // strip out the bundle path (already chdir'd to there, so not needed)
        for(i=realPathLen+1;i<=helpPathLen;i++)
            helpPath[i-realPathLen-1]=helpPath[i];
        helpPathLen=strlen(helpPath);
    }
    if(helpPathLen+openstrlen>509) {
        printf("%s: path to Info file too long: %s\n",PROGNAME,helpPath);
        ShowAlert(READMEPATH_NAME,1,0);
        return -1;
    }
    printf("%s info: helpPathLen: %d\n",PROGNAME,helpPathLen);
    printf("%s info: helpPath: %s\n",PROGNAME,helpPath);
    for(i=helpPathLen;i>=0;i--)
        helpPath[i+openstrlen]=helpPath[i];
    for(i=0;i<openstrlen;i++)
        helpPath[i]=openstr[i];
    helpPathLen=strlen(helpPath);
    printf("%s info: help command (%d): %s\n",PROGNAME,helpPathLen,helpPath);
    system(helpPath);
    // extra bit to make sure TextEdit comes in front...
    sleep(1);
    system(openstr);
    return helpPathLen;
}

void ShowOroborOSXHelp()
{
    if(ShowHelpFile(README_FILEID)<=0)
// Failed, so just use the About box...
        DoAboutBox();
}

void ShowThemesInfoFile()
{
    if(ShowHelpFile(THEMES_FILEID)<=0)
// Failed, so just use the About box...
        DoAboutBox();
}

void ShowHistoryFile()
{
    if(ShowHelpFile(HISTORY_FILEID)<=0)
// Failed, so just use the About box...
        DoAboutBox();
}

void ShowLicenseFile()
{
    if(ShowHelpFile(LICENSE_FILEID)<=0)
// Failed, so just use the About box...
        DoAboutBox();
}

void ShowLMIInfoFile()
{
    if(ShowHelpFile(LMI_FILEID)<=0)
// Failed, so just use the About box...
        DoAboutBox();
}

void ShowHelpersInfoFile()
{
    if(ShowHelpFile(HELPERS_FILEID)<=0)
// Failed, so just use the About box...
        DoAboutBox();
}

void ShowRulesInfoFile()
{
    if(ShowHelpFile(RULES_FILEID)<=0)
// Failed, so just use the About box...
        DoAboutBox();
}

/*
 * Many thanks to Dave Vasilevsky for providing the following code to store preferences!
 */
int getIntPref(const char* id, int defaultVal)
{
    Boolean validKey;
    CFStringRef prefID=CFStringCreateWithCString(NULL, id, kCFStringEncodingASCII);
    int storedVal=CFPreferencesGetAppIntegerValue(prefID, kCFPreferencesCurrentApplication, &validKey);
    CFRelease(prefID);
    if (validKey)
        return storedVal;
    else
        return defaultVal;
}

void setIntPref(const char* id, int newVal)
{
    CFStringRef prefID=CFStringCreateWithCString(NULL, id, kCFStringEncodingASCII);
    CFNumberRef valNum=CFNumberCreate(kCFAllocatorDefault, kCFNumberIntType, &newVal);
    CFPreferencesSetAppValue(prefID, valNum, kCFPreferencesCurrentApplication);
    CFRelease(prefID);
    CFRelease(valNum);
}

// Returns a pointer to newly allocated memory; the caller is responsible for freeing it.
char* getStringPref(const char* id, const char* defaultVal)
{
    Boolean		validKey;
    CFStringRef	prefID, storedVal;
    int			bufSize;
    const char*	retBuf;
	
    prefID=CFStringCreateWithCString(NULL, id, kCFStringEncodingASCII);
    if (NULL != prefID)
    {
        storedVal=CFPreferencesCopyAppValue(prefID, kCFPreferencesCurrentApplication);
        CFRelease(prefID);
		
        if (NULL != storedVal)
        {
            bufSize=CFStringGetMaximumSizeForEncoding(CFStringGetLength(storedVal), kCFStringEncodingASCII)+1;
            retBuf=malloc(bufSize);
            if(retBuf==NULL)
            {
                if(on_cmd_line) {
                    fprintf(stderr, "%s: Memory allocation failed in getStringPref.\n", PROGNAME);
                    ClearUpSockets();
                    exit(1);
                } else {
                    fprintf(stderr, "%s: Memory allocation failed in getStringPref.\n", PROGNAME);
                    gQuitFlag=45;
                }
            } else {
                if ( CFStringGetCString(storedVal, retBuf, bufSize, kCFStringEncodingASCII) )
                    return retBuf;
            }
        }
    }
	
    if (NULL != defaultVal)
        return strdup(defaultVal);
    else
        return NULL;
}

void setStringPref(const char* id, const char* newVal)
{
    CFStringRef prefID, valStr;
    prefID=CFStringCreateWithCString(NULL, id, kCFStringEncodingASCII);
    if (NULL != prefID) {
        CFStringRef valStr=CFStringCreateWithCString(NULL, newVal, kCFStringEncodingASCII);
        if (NULL != valStr) {
            CFPreferencesSetAppValue(prefID, valStr, kCFPreferencesCurrentApplication);
            CFRelease(valStr);
        }
        CFRelease(prefID);
    }
}

char *Get_XDarwin_Keymap()
{
    // start with USA keymapping for now...
    char *ret=malloc(15);
    if(ret) sprintf(ret,"USA");
    return ret;
}

void InitPrefs()
{
    /* variable             pref type       pref ID                  default */
    iconbarpos            = getIntPref   ( kPrefIconbarPos,          ICONBARPOS_TOPLEFT );
    iconbar_steps         = getIntPref   ( kPrefIconbarSteps,        ICONSTEPS_MED      );
    iconbar_screen        = getIntPref   ( kPrefIconbarScreen,       0                  );
    shrinking_iconbars    = getIntPref   ( kPrefIconbarShrinking,    1                  );
    gHiding_Iconbars      = getIntPref   ( kPrefIconbarHiding,       1                  );
    gThemeDir             = getStringPref( kPrefThemeName,           NULL               );
    gKeymapName           = getStringPref( kPrefKeymapName,          NULL               );
    gKeymapGlobal	  = getIntPref   ( kPrefKeymapGlobal,	     1			);
    gUseShapedTheme       = getIntPref   ( kPrefThemeShaped,         1                  );
    gBGWinSetting         = getIntPref   ( kPrefBGWinSetting,        BGWIN_NOTHING      );
    gInterleaving_Windows = getIntPref   ( kPrefInterleavingWindows, 1                  );
    gMinMethod		  = getIntPref   ( kPrefMinMethod,	     minmethod_dock	);
    gQuietStartup	  = getIntPref	 ( kPrefQuietStartup,	     0			);
    gIncludeOffScreen	  = getIntPref	 ( kIncludeOffScreen,	     0			);
    if(gKeymapName==NULL) gKeymapName=Get_XDarwin_Keymap();
}

void SavePrefs()
{
    /* pref type      pref ID                 variable */
    setIntPref   ( kPrefIconbarPos,          iconbarpos            );
    setIntPref   ( kPrefIconbarScreen,       iconbar_screen        );
    setIntPref   ( kPrefIconbarSteps,        iconbar_steps         );
    setIntPref   ( kPrefIconbarShrinking,    shrinking_iconbars    );
    setIntPref   ( kPrefIconbarHiding,       gHiding_Iconbars      );
    if(gThemeDir!=NULL)
        setStringPref( kPrefThemeName,       gThemeDir             );
    if(gKeymapName!=NULL)
        setStringPref( kPrefKeymapName,      gKeymapName           );
    setIntPref   ( kPrefKeymapGlobal,        gKeymapGlobal	   );
    setIntPref   ( kPrefThemeShaped,         gUseShapedTheme       );
    setIntPref   ( kPrefBGWinSetting,        gBGWinSetting         );
    setIntPref   ( kPrefInterleavingWindows, gInterleaving_Windows );
    setIntPref   ( kPrefMinMethod,	     gMinMethod		   );
    setIntPref   ( kPrefQuietStartup,	     gQuietStartup	   );
    if(gGotCVDHidden!=0)
        setIntPref   ( kIncludeOffScreen,    gIncludeOffScreen	   );
	
    CFPreferencesAppSynchronize(kCFPreferencesCurrentApplication);
    printf("%s info: saved preferences (%d)\n",PROGNAME,gQuitFlag);
 }

