/*************************************/ 
/* Original oroborus window manager  */
/* (c) Ken Lynch Jan 2001            */
/*                                   */
/* Extra functionality for OroborOSX */
/* (c) Adrian Umpleby Jan 2002       */
/*                                   */
/* Distributed under the GPL         */ 
/* See LICENSE for more details      */ 
/*************************************/ 

/* hackcmds.h */

#ifndef OROB_HACKCMDS_H 
#define OROB_HACKCMDS_H 

// this is the special pair of 'trigger' values for the hack commands
#define HACKCMD_STARTX -23451
#define HACKCMD_STARTY -6789

#define HACKCMD_TRANSLUCENT	-23400
#define HACKCMD_DOCKWIN		-23401
#define HACKCMD_DIMWIN		-23402
#define HACKCMD_DOSHADOW	-23402
#define HACKCMD_ALLTOFRONT	-23403
#define HACKCMD_SETSHADOW	-23404
#define HACKCMD_SETDRAWALPHA	-23405
#define HACKCMD_SETBG_ARGB	-23406
#define HACKCMD_SETBG_ALPHA	-23406
#define HACKCMD_SETBG_RED	-23407
#define HACKCMD_SETBG_GREEN	-23408
#define HACKCMD_SETBG_BLUE	-23409
#define HACKCMD_HIDE_ALLXWIN	-23410
#define HACKCMD_HITCHECK	-23411
#define HACKCMD_HITCHECK_X	-23411
#define HACKCMD_HITCHECK_Y	-23412
//main and alternating miniwin command values -to avoid case where same values would be sent
#define HACKCMD_MINIWIN_TITLE	-23414
#define HACKCMD_MINIWIN_TITLE1	-23413
#define HACKCMD_MINIWIN_TITLE2	-23415
#define HACKCMD_INHIBITINFO	-23416
#define HACKCMD_ALLOWFRONT	-23417
#define HACKCMD_DEACTIVATE	-23418
#define HACKCMD_UNGRABPTR	-23419
#define HACKCMD_CHANGEMODS	-23424
#define HACKCMD_SENDMODS	-23425
#define HACKCMD_SENDKEYDOWN	-23426
#define HACKCMD_SENDKEYUP	-23427
#define HACKCMD_HIDEWINDOW	-23432
#define HACKCMD_SETFIRSTCLICK	-23433
#define HACKCMD_SETWHOLESCREEN	-23434
#define HACKCMD_UPDATEROOTW	-23435
#define HACKCMD_UPDATEROOTH	-23436
#define HACKCMD_UPDATEROOTX	-23437
#define HACKCMD_UPDATEROOTY	-23438
#define HACKCMD_COMEINFRONT	-23440
#define HACKCMD_SETCURWIN	-23455
#define HACKCMD_SETWINPOS	-23456
#define HACKCMD_SETWINPOS_X	-23456
#define HACKCMD_SETWINPOS_Y	-23457

//#define HACKCMD_INHIBITREFRESH	-23449
//#define HACKCMD_INHIBITFULL	-23450

#define HACKCMD_VERBOSECONSOLE	-23459
#define HACKCMD_INHIBITLEVEL	-23460
#define HACKARG_INHIBITALL	40
#define HACKARG_INHIBITDRAW	30
#define HACKARG_INHIBITREFRESH	20
#define HACKARG_INHIBITSCREEN	10
#define HACKARG_INHIBITNONE	0
#define HACKCMD_UPDATEALL	-23461

// This is a very special pair of values to ask for the cursor position as quickly as possible
#define HACKCMD_MOUSEMOVED_X	-23451
#define HACKCMD_MOUSEMOVED_Y	-9876
// tell XDarwin to connect to the listen socket
#define HACKCMD_COMMUNICATE	-23490
// tell XDarwin we are quitting
#define HACKCMD_QUITXDARWIN	-23495
// to tell XDarwin its prefs window was opened
#define HACKCMD_SHOWINGPREFS	-23498
// last one, used to set HACKID for window
#define HACKCMD_SETID		-23499

extern int can_send_hackcmds, inhibiting_info;

#endif /* OROB_HACKCMDS_H */
