/*************************************/ 
/* Original oroborus window manager  */
/* (c) Ken Lynch Jan 2001            */
/*                                   */
/* Extra functionality for OroborOSX */
/* (c) Adrian Umpleby Jan 2002       */
/*                                   */
/* Distributed under the GPL         */ 
/* See LICENSE for more details      */ 
/*************************************/ 
 
#ifndef OROB_ICONBARS_H 
#define OROB_ICONBARS_H 

#include "oroborus.h" 

// number of steps for iconbars -now defined in common.h
//#define ICONSTEPS_FAST 4
//#define ICONSTEPS_MED 7
//#define ICONSTEPS_SLOW 20

// not currently used -would be for hiding/showing of iconbars, but it's too slow...
#define SLIDESTEP 45

/* Icon-bar modes */
#define NOT_ICONBAR		0
#define ICONBAR_VISIBLE		1
#define ICONBAR_RAISED		2
#define ICONBAR_HIDDEN		3

extern int iconbar_steps, icontab_width, iconbar_width;

/* iconbars.c */
extern void change_iconbarpos(int);
extern void compress_iconbars();
extern void minmax_client(Client *);
extern void unhide_all_iconbars();
extern void slide_all_iconbars(Client *c);
extern void change_iconbar_menuspace();
extern void change_iconbar_screen(int newhead);
extern int get_icontab_width();

#endif /* OROB_ICONBARS_H */
