/*
 * XWindow category for Mac OS X rootless X server
 *
 * Based on original XCarbonWindow.h
 * Copyright (c) 2002 Torrey T. Lyons. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name(s) of the above copyright
 * holders shall not be used in advertising or otherwise to promote the sale,
 * use or other dealings in this Software without prior written authorization.
 */
/* $XFree86: xc/programs/Xserver/hw/darwin/quartz/XCarbonWindow.h,v 1.1 2002/03/28 02:21:18 torrey Exp $ */

#import <AppKit/NSWindow.h>
#import "XView.h"

@interface XWindow : NSWindow
{
    XView *mView;
    BOOL mOneOfMine;
    BOOL mIsKey;
    int mStyleMask;
    char *mOrobTitle;
    BOOL mIsIconBar;
    int mLastTitlePos;
    NSRect mMyFrame;
    BOOL mCheckingFrame;
}


- (void)close;
- (void)displayIfNeeded;
- (void)display;
- (void)mySetContentView:(XView *)theView;
- (void)setMyTitlePart:(int)v;
- (void)myMakeKeyAndOrderFront:(id)sender;
- (void)makeKeyAndOrderFront:(id)sender;
- (void)myMakeKeyWindow;
- (void)makeKeyWindow;
- (void)myMakeMainWindow;
- (void)makeMainWindow;
- (void)myOrderFront:(id)sender;
- (void)orderFront:(id)sender;
- (void)myOrderWindow:(NSWindowOrderingMode)place relativeTo:(int)otherWindowNumber;
- (void)orderWindow:(NSWindowOrderingMode)place relativeTo:(int)otherWindowNumber;
- (void)myOrderOut:(id)sender;
- (void)orderOut:(id)sender;
- (void)checkFrame;
- (void)mySetFrameOrigin:(NSPoint)aPoint;
- (void)setFrameOrigin:(NSPoint)aPoint;
- (void)mySetFrameTopLeftPoint:(NSPoint)topLeft;
- (void)setFrameTopLeftPoint:(NSPoint)topLeft;
- (void)mySetFrame:(NSRect)newframe display:(BOOL)val;
- (void)setFrame:(NSRect)newframe display:(BOOL)val;
- (void)windowDidDeminiaturize:(NSNotification *)notification;
- (void)windowDidMove:(NSNotification *)notification;
- (void)windowWillMove:(NSNotification *)notification;
- (NSSize)windowWillResize:(NSWindow *)sender toSize:(NSSize)proposedFrameSize;
- (void)windowDidResize:(NSNotification *)notification;
- (void)setOneOfMine:(BOOL)val;
- (BOOL)canBecomeMainWindow;
- (BOOL)canBecomeKeyWindow;
- (NSRect)constrainFrameRect:(NSRect)frameRect toScreen:(NSScreen *)screen;
- (void)myResignKey;
//- (BOOL)isKeyWindow;
//- (int)isAutodisplay;
//- (int)styleMask;
- (void)mySetStyleMask:(unsigned int)val;

@end
