/*
 * XWindow category for Mac OS X rootless X server
 *
 * This category extends/replaces the functionality of NSWindow.
 *
 * Based on original XCarbonWindow.m
 * Copyright (c) 2002 Torrey T. Lyons. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name(s) of the above copyright
 * holders shall not be used in advertising or otherwise to promote the sale,
 * use or other dealings in this Software without prior written authorization.
 */
/* $XFree86: xc/programs/Xserver/hw/darwin/quartz/XCarbonWindow.m,v 1.1 2002/03/28 02:21:18 torrey Exp $ */

#include "communication.h"
#import "XWindow.h"

extern XWindow *currentKeyWindow;

@implementation XWindow

- (void)displayIfNeeded
{
//    [super displayIfNeeded];
    //NSLog(@"About to lockFocus (displayIfNeeded)...");
    [mView lockFocus];
    //NSLog(@"About to drawRect...");
    [mView drawRect:[mView frame]];
    //NSLog(@"Done drawRect...");
    [mView unlockFocus];
    //NSLog(@"Done unlockFocus...");
}

- (void)display
{
//    [super display];
    //NSLog(@"About to lockFocus...");
    [mView lockFocus];
    //NSLog(@"About to drawRect...");
    [mView drawRect:[mView frame]];
    //NSLog(@"Done drawRect...");
    [mView unlockFocus];
    //NSLog(@"Done unlockFocus...");
}

- (void)mySetContentView:(XView *)theView
{
    mCheckingFrame = NO;
    mMyFrame = [self frame];
    mView = theView;
    //NSLog(@">>>>>>> Set contentView correctly...");
    [super setContentView:theView];
    mIsKey = NO;
    mOrobTitle = malloc(130);
    mIsIconBar = NO;
    mLastTitlePos = 0;
}

- (void)myMakeKeyAndOrderFront:(id)sender
{
    BOOL oldOneOfMine = mOneOfMine;
    [self setOneOfMine:YES];
    [super makeKeyAndOrderFront:sender];
    mOneOfMine = oldOneOfMine;
}

- (void)makeKeyAndOrderFront:(id)sender
{
// This is used by CodeTek VirtualDesktop 2.0.1 before setting the top window
// We 'trap' it so that the X server can be updated with the info
        int myID=[mView getMyHackID];
        //NSLog(@"***** GOT INTO MAKEKEYANDORDERFRONT!!! (%d %d)",myID,mOneOfMine);
        if(!mOneOfMine) {
            if(myID>0) {
                //mOneOfMine=YES;
                //[super makeKeyWindow];
                //mOneOfMine=NO;
                [mView sendSpecialEvent:-9999 which:30002 dx:1 dy:0];
            } else
                NSLog(@"***** GOT INTO MAKEKEYANDORDERFRONT!!!");
            /*if(![self checkMyFrame]) {
                NSTimer *aTimer;
                aTimer = [NSTimer scheduledTimerWithTimeInterval:0.3 target:self
                        selector:@selector(delayedFrameCheck:) userInfo:nil repeats:NO];
            }*/
        } else if(myID>0)
            [super makeKeyAndOrderFront:sender];
        else
            [super orderFront:sender];
}

- (void)myMakeKeyWindow
{
    //BOOL oldOneOfMine = mOneOfMine;
    //mOneOfMine = YES;
    //[super makeKeyWindow];
    //mOneOfMine = oldOneOfMine;
    mIsKey = YES;
    if(currentKeyWindow)
        [currentKeyWindow myResignKey];
    currentKeyWindow = self;
}

- (void)myResignKey
{
    mIsKey = NO;
}
/*
- (BOOL)isKeyWindow
{
    return mIsKey;
}

- (int)styleMask
{
    return mStyleMask;
}

- (int)isAutodisplay
{
    if(mStyleMask==0)
        return NO;
    else
        return YES;
}
*/
- (void)mySetStyleMask:(unsigned int)val
{
    mStyleMask = val;
}

- (void)makeKeyWindow
{
// This is used by CodeTek VirtualDesktop 2.1 before setting the top window
// We 'trap' it so that the X server can be updated with the info
        int myID=[mView getMyHackID];
        //NSLog(@"***** GOT INTO MAKEKEYWINDOW!!! %d",myID);
        if(!mOneOfMine) {
            if(myID>0) {
                //mOneOfMine=YES;
                //[super makeKeyWindow];
                //mOneOfMine=NO;
                [mView sendSpecialEvent:-9999 which:30002 dx:1 dy:0];
            } else
                NSLog(@"***** GOT INTO MAKEKEYWINDOW!!!");
            /*if(![self checkMyFrame]) {
                NSTimer *aTimer;
                aTimer = [NSTimer scheduledTimerWithTimeInterval:0.3 target:self
                        selector:@selector(delayedFrameCheck:) userInfo:nil repeats:NO];
            }*/
        } /*else if(myID>0)
            [super makeKeyWindow];*/
}

- (void)myMakeMainWindow
{
    BOOL oldOneOfMine = mOneOfMine;
    [self setOneOfMine:YES];
    [super makeMainWindow];
    mOneOfMine = oldOneOfMine;
}

- (void)makeMainWindow
{
        int myID=[mView getMyHackID];
        if(verboseConsole)
            NSLog(@"***** GOT INTO MAKEMAINWINDOW!!! %d",myID);
        [super makeMainWindow];
}

- (void)myOrderFront:(id)sender
{
    BOOL oldOneOfMine = mOneOfMine;
    [self setOneOfMine:YES];
    [super orderFront:sender];
    mOneOfMine = oldOneOfMine;
}

- (void)orderFront:(id)sender
{
        int myID=[mView getMyHackID];
        if(verboseConsole)
            NSLog(@"***** GOT INTO ORDERFRONT!!! %d",myID);
        if(!mOneOfMine) {
            if(myID>0)
                [mView sendSpecialEvent:-9999 which:30002 dx:1 dy:0];
//            else
            /*if(![self checkMyFrame]) {
                NSTimer *aTimer;
                aTimer = [NSTimer scheduledTimerWithTimeInterval:0.3 target:self
                        selector:@selector(delayedFrameCheck:) userInfo:nil repeats:NO];
            }*/
        } else
            [super orderFront:sender];
}

- (void)myOrderWindow:(NSWindowOrderingMode)place relativeTo:(int)otherWindowNumber
{
    BOOL oldOneOfMine = mOneOfMine;
    [self setOneOfMine:YES];
    [super orderWindow:place relativeTo:otherWindowNumber];
    mOneOfMine = oldOneOfMine;
}

- (void)orderWindow:(NSWindowOrderingMode)place relativeTo:(int)otherWindowNumber
{
        int myID=[mView getMyHackID];
//            [super orderWindow:place relativeTo:otherWindowNumber];
//                NSLog(@"***** GOT INTO ORDERWINDOW!!! (%d,%d) %d",
//					place,otherWindowNumber,myID);
        if(!mOneOfMine) {
            if(myID>0)
                [mView sendSpecialEvent:-9999 which:30002 dx:place dy:otherWindowNumber];
            else
                NSLog(@"***** GOT INTO ORDERWINDOW!!! (%d,%d)",place,otherWindowNumber);
            /*if(![self checkMyFrame]) {
                NSTimer *aTimer;
                aTimer = [NSTimer scheduledTimerWithTimeInterval:0.3 target:self
                        selector:@selector(delayedFrameCheck:) userInfo:nil repeats:NO];
            }*/
//        }
        } else
            [super orderWindow:place relativeTo:otherWindowNumber];
}

- (void)myOrderOut:(id)sender
{
        BOOL oldOneOfMine=mOneOfMine;
        [self setOneOfMine:YES];
        [super orderOut:sender];
        mOneOfMine=oldOneOfMine;
}

- (void)close
{
    if(mOrobTitle) free(mOrobTitle);
    [self setOneOfMine:YES];
    [super close];
}

- (void)orderOut:(id)sender
{
        int myID=[mView getMyHackID];
        if(!mOneOfMine) {
            if(myID>0) {
                [mView sendSpecialEvent:-9999 which:30003 dx:1 dy:1];
                //[mView setMyHide:YES];
            } else
                NSLog(@"***** GOT INTO ORDEROUT!!!",myID);
        } else
            [super orderOut:sender];
}

- (void)mySetFrameOrigin:(NSPoint)aPoint
{
        BOOL oldOneOfMine=mOneOfMine;
        [self setOneOfMine:YES];
        [super setFrameOrigin:aPoint];
        mMyFrame = [self frame];
        mOneOfMine=oldOneOfMine;
}

- (void)setFrameOrigin:(NSPoint)aPoint
{
        if(!mOneOfMine) {
            NSLog(@"PrivateID %d (%d) : Got into setFrameOrigin...",
                                [mView getMyPrivateID],[mView getMyHackID]);
            [self checkFrame];
        } else {
            [super setFrameOrigin:aPoint];
            mMyFrame = [self  frame];
        }
}

- (void)mySetFrameTopLeftPoint:(NSPoint)topLeft
{
        BOOL oldOneOfMine=mOneOfMine;
        [self setOneOfMine:YES];
        [super setFrameTopLeftPoint:topLeft];
        mMyFrame = [self frame];
        mOneOfMine=oldOneOfMine;
}

- (void)setFrameTopLeftPoint:(NSPoint)topLeft
{
        if(!mOneOfMine) {
            NSLog(@"PrivateID %d (%d) : Got into setFrameTopLeftPoint...",
                                [mView getMyPrivateID],[mView getMyHackID]);
            [self checkFrame];
        } else {
            [super setFrameTopLeftPoint:topLeft];
            mMyFrame = [self frame];
        }
}

- (void)setMyTitlePart:(int)v
{
    if(mOrobTitle==NULL) {
        NSLog(@"***** Got NULL mOrobTitle in setMyTitlePart %d",v);
        return;
    }
    if(v==-2) {
        char *tmpTitle=malloc(strlen(mOrobTitle)+5);
        mIsIconBar=YES;
        if(verboseConsole)
            NSLog(@"prepending window title %d %#lx",mIsIconBar,mOrobTitle);
        sprintf(tmpTitle,"-  %s",mOrobTitle);
        [self setTitle:[NSString stringWithCString:tmpTitle]];
        mLastTitlePos = 0;
        free(tmpTitle);
    } else if(v==-1) {
        mLastTitlePos = 0;
        if(verboseConsole)
            NSLog(@"restarting window title (%#lx %d)",mOrobTitle,mOrobTitle[0]);
    } else if(v==0) {
        mOrobTitle[mLastTitlePos] = 0;
        mIsIconBar=NO;
        if(verboseConsole)
            NSLog(@"committing window title (%d): %s",mIsIconBar,mOrobTitle);
        [self setTitle:[NSString stringWithCString:mOrobTitle]];
        mLastTitlePos = 0;
    } else {
        //NSLog(@"setting window title at %d: %#lx",mLastTitlePos,v);
        mOrobTitle[mLastTitlePos] = v & 0xff;
        mLastTitlePos++;
    }
}

- (void)checkFrame
{
    NSRect frame=[self frame];
    int hackID=[mView getMyHackID];
    
    mCheckingFrame = YES;
    
    if( mOneOfMine ) {
        int i = 0;
        mCheckingFrame = NO;
        usleep(10000);
        while( mOneOfMine ) {
            i++;
            if( i > 50 ) { // just hope for the best if we're waiting too long
                NSLog(@"Giving up waiting for mOneOfMine in checkFrame...");
                mOneOfMine = NO;
            } else if( i > 20 ) {
                NSLog(@"Waiting for mOneOfMine in checkFrame...");
            }
            usleep(10000);
        }
        mCheckingFrame = YES;
    }
    
    // HackID -999 is the special check_win - this helps OroborOSX detect screen changes, so
    // we send the info regardless of any change in the actual window position
    if( frame.origin.x!=mMyFrame.origin.x || frame.origin.y!=mMyFrame.origin.y || hackID==-999 ) {
        NSLog(@"Origin has changed: %d,%d to %d,%d",
            (int)mMyFrame.origin.x,(int)mMyFrame.origin.y,(int)frame.origin.x,(int)frame.origin.y);
        if( hackID>0 || hackID==-999 ) {
            [mView sendSpecialEvent:-9999 which:30000 dx:(int) frame.origin.x
                                    dy:(int) (frame.origin.y+frame.size.height)];
            mMyFrame.origin = frame.origin;
        } else {
            [self mySetFrame:mMyFrame display:NO];
            return;	// no need to check dimensions
        }
    }
    
    if( frame.size.width!=mMyFrame.size.width || frame.size.height!=mMyFrame.size.height ) {
        NSLog(@"Size has changed: %dx%d to %dx%d",
                        (int)mMyFrame.size.width,(int)mMyFrame.size.height,
                        (int)frame.size.width,(int)frame.size.height);
        if( hackID>0 ) {
            [mView sendSpecialEvent:-9999 which:30001 dx:(int) frame.size.width
                                                        dy:(int) frame.size.height];
            mMyFrame.origin = frame.origin;
        } else
            [self mySetFrame:mMyFrame display:NO];
    }

    mCheckingFrame = NO;
}

- (void)mySetFrame:(NSRect)newframe display:(BOOL)val
{
        BOOL oldOneOfMine=mOneOfMine;
        
        [self setOneOfMine:YES];
//        NSLog(@"Starting setFrame...");
//        [super setFrame:newframe display:val];
        mMyFrame = newframe;
        [super _setFrameCommon:newframe display:val stashSize:nil];
//        NSLog(@"Done setFrame...");
        mOneOfMine=oldOneOfMine;
}

- (void)setFrame:(NSRect)newframe display:(BOOL)val
{
    if(!mOneOfMine) {
        NSLog(@"PrivateID %d (%d) : Got into setFrame...",
                                [mView getMyPrivateID],[mView getMyHackID]);
        [self checkFrame];
    } else {
        mMyFrame = newframe;
        [super setFrame:newframe display:NO];
    }
}

- (void)windowDidDeminiaturize:(NSNotification *)notification
{
    [mView windowDidDeminiaturize:notification];
}

- (void)windowDidMove:(NSNotification *)notification
{
    if(!mOneOfMine) {
        NSLog(@"PrivateID %d (%d) : Got into WindowDidMove...",
                                [mView getMyPrivateID],[mView getMyHackID]);
        [self checkFrame];
    }
}

- (void)windowWillMove:(NSNotification *)notification
{
    if(!mOneOfMine)
        NSLog(@"PrivateID %d : Got into WindowWillMove...",[mView getMyPrivateID]);
}

- (void)windowDidResize:(NSNotification *)notification
{
    if(!mOneOfMine)
        NSLog(@"PrivateID %d : Got into windowDidResize...",[mView getMyPrivateID]);
}

- (NSSize)windowWillResize:(NSWindow *)sender toSize:(NSSize)proposedFrameSize
{
    if(!mOneOfMine)
        NSLog(@"PrivateID %d : Got into windowWillResize...",[mView getMyPrivateID]);
    return proposedFrameSize;
}

- (NSRect)constrainFrameRect:(NSRect)frameRect toScreen:(NSScreen *)screen
{
    return frameRect;
}

- (void)setOneOfMine:(BOOL)val
{
    if( mOneOfMine==val ) return;

    if(mCheckingFrame) {
        int i = 0;
        usleep(10000);
        while(mCheckingFrame) {
            i++;
            if( i > 50 ) { // give up eventually - hope for the best!
               NSLog(@"Give up waiting for mCheckingFrame in setOneOfMine...");
               mCheckingFrame = NO;
            } else {
               NSLog(@"Waiting for mCheckingFrame in setOneOfMine...");
               usleep(10000);
            }
        }
    }
    mOneOfMine=val;
}

- (BOOL)canBecomeMainWindow
{
    return NO;
}

- (BOOL)canBecomeKeyWindow
{
    return NO;
}

@end
