/*
 * Common internal definitions and code of the rootless implementation
 * for the Mac OS X Aqua environment
 */
/*
 * Copyright (c) 2002 Torrey T. Lyons. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
 * THE ABOVE LISTED COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 *
 * Except as contained in this notice, the name(s) of the above copyright
 * holders shall not be used in advertising or otherwise to promote the sale,
 * use or other dealings in this Software without prior written authorization.
 */

#ifndef _AQUACOMMON_H
#define _AQUACOMMON_H

#include "quartzCommon.h"

#ifdef __OBJC__
#undef BOOL
#import <Cocoa/Cocoa.h>
#import "XWindow.h"
#else
typedef struct OpaqueNSWindow XWindow;
typedef struct OpaqueXView XView;
#endif

#define OROB_WINDOW_HIDDEN		1
#define OROB_WINDOW_DOCKED		2
#define OROB_WINDOW_FIRSTCLICK		4
#define OROB_WINDOW_SHADOWINHIBIT	8
#define OROB_WINDOW_SHAPEINHIBIT	16
#define OROB_WINDOW_MOVEINHIBIT		32
#define OROB_WINDOW_NOFLUSH		128
#define OROB_WINDOW_NOTDRAWN		256
#define OROB_WINDOW_NEEDSFLUSH		512
//#define OROB_WINDOW_LOCKDIRTY		1024
#define OROB_WINDOW_DRAWING		2048

typedef struct {
    XWindow *window;
    XView *view;
    GrafPtr port;
    CGContextRef context;
    GWorldPtr rootGWorld;
    RgnHandle dirtyRgn;
    int hackID;
    int privateID;
    int window_state;
    int undrawn_x;
    int undrawn_y;
    int alpha_mask;
    int transBG_mask;
} AquaWindowRec;

#define AQUA_WINREC(rw) ((AquaWindowRec *)rw)

#endif /* _AQUACOMMON_H */
