/*
 * communication.c
 */

#include "communication.h"

int oroborosx_socket=0, verboseConsole=0;

int init_socket_connect(char *pathstr, char *myname)
{
    int s, len;
    struct sockaddr_un remote;
    
    if ((s = socket(AF_UNIX,SOCK_STREAM,0))==-1) {
        perror("socket");
        return -1;
    }

    printf("XDarwin info: Trying to connect to OroborOSX socket...\n");

    remote.sun_family=AF_UNIX;
    strcpy(remote.sun_path,pathstr);
    len = strlen(remote.sun_path) + sizeof(remote.sun_family) + 1;
    if(connect(s,(struct sockaddr *)&remote,len)==-1) {
        perror("connect");
        return -2;
    }

    printf("XDarwin info: Connected. (%d)\n",s);
    
    len = strlen(myname);
    if(send(s,&len,4,0)==-1) {
        perror("len send in init_socket_connect");
        return -3;
    }
    if(send(s,myname,len,0)==-1) {
        perror("name send in init_socket_connect");
        return -4;
    }

    return s;
}

int send_bytes_to_socket(int s, int msglen, char *str)
{
    if(send(s,&msglen,4,0)==-1) {
        perror("len send in send_bytes_to_socket");
        return -3;
    }
    
    if(msglen>0)
        if(send(s,str,msglen,0)==-1) {
            perror("name sendin send_bytes_to_socket");
            return -4;
        }
        
    return 0;
}


