#define XP_NO_X_HEADERS
#include "../xpr/Xplugin.h"
//#define GOT_REAL_XP
#include "dummyxp.h"

int myxp_use_xp_cursor=1;

int myxp_fill_test( unsigned int length )
{
    if( length > xp_fill_bytes_threshold ) return 0;
    return -1;
}

int myxp_copy_test( unsigned int length )
{
    if( length > xp_copy_bytes_threshold ) return 0;
    return -1;
}

myxp_error myxp_init(int v)
{
    return xp_init(v);
}

myxp_error myxp_set_cursor (int width, int height, int hot_x, int hot_y,
                                uint32_t *data, uint32_t rowbytes)
{
        return xp_set_cursor( width, height, hot_x, hot_y, data, rowbytes);
}

myxp_error myxp_hide_cursor()
{
    return xp_hide_cursor();
}

myxp_error myxp_show_cursor()
{
    return xp_show_cursor();
}

/* Fill HEIGHT rows of data starting at DST. Each row will have WIDTH
   bytes filled with the 32-bit pattern VALUE. Each row is DST-ROWBYTES
   wide in total. */

myxp_error myxp_fill_bytes (unsigned int width,
			       unsigned int height, uint32_t value,
			       void *dst, unsigned int dst_rowbytes)
{
	xp_fill_bytes (width, height, value,
		           dst, dst_rowbytes);
    return 0;
}

/* Copy HEIGHT rows of bytes from SRC to DST. Each row will have WIDTH
   bytes copied. CONVERSION defines a possible conversion function to
   be applied to the data as it's being copied. Unless specified
   otherwise SRC and DST may overlap, and the right thing will happen. */

myxp_error myxp_copy_bytes (unsigned int width, unsigned int height,
			       int nmiddle, int conversion,
			       void *src, unsigned int src_rowbytes,
			       void *dst, unsigned int dst_rowbytes)
{
    if( conversion == XP_COPY_BYTES ) {
	    xp_copy_bytes (width, height,
			           src, src_rowbytes,
			           dst, dst_rowbytes);
        return 0;
    } else {
        /* need to copy XRGB to ARGB */
        void *srcp[2], *dest[2];
        unsigned int srcp_rowbytes[2], dest_rowbytes[2];
        unsigned int fn;
        
        srcp[0] = (char *) src;
        srcp[1] = NULL;
        srcp_rowbytes[0] = src_rowbytes;
        srcp_rowbytes[1] = 0;
        
        dest[0] = (char *) dst;
        dest[1] = dest[0];
        dest_rowbytes[0] = dst_rowbytes;
        dest_rowbytes[1] = dest_rowbytes[0];
        
        fn = XP_COMPOSITE_FUNCTION (XP_COMPOSITE_SRC, XP_DEPTH_ARGB8888,
                                    XP_DEPTH_NIL, XP_DEPTH_ARGB8888);
        
        return xp_composite_pixels (nmiddle,height,fn,srcp,srcp_rowbytes,
                                    NULL,0,dest,dest_rowbytes);
    }
}

/* Composite HEIGHT rows of bytes from SRC and DST to DST, possibly
   using VALUE to specify a constant parameter to the compositing
   function. Each row will have WIDTH bytes composited. */

myxp_error myxp_composite_bytes (unsigned int width, unsigned int height,
				    uint32_t value,
				    void *src, unsigned int src_rowbytes,
				    void *dst, unsigned int dst_rowbytes)
{
    void *srcp[2], *destp[2];
    unsigned int dest_rowbytes[2];
    unsigned int fn;
    
    if( width * height <= xp_composite_area_threshold )
        return -1;
    
    srcp[0] = &src; srcp[1] = &src;
    /* null rowbytes pointer means use first value as constant */
    destp[0] = dst; destp[1] = dst;
    dest_rowbytes[0] = dst_rowbytes; dest_rowbytes[1] = dest_rowbytes[0];
    fn = XP_COMPOSITE_FUNCTION (XP_COMPOSITE_OVER, XP_DEPTH_ARGB8888,
                                XP_DEPTH_A8, XP_DEPTH_ARGB8888);
                                
	return xp_composite_pixels (width, height, fn, srcp, NULL,
				                src, src_rowbytes,
				                destp, dest_rowbytes);
}
