#define XP_NO_X_HEADERS
#include "/usr/X11R6/include/xp/x-plugin.h"
#define GOT_REAL_XP
#include "dummyxp.h"

int myxp_use_xp_cursor=1;

int myxp_fill_test( unsigned int length )
{
    if( length > xp_fill_bytes_threshold ) return 0;
    return -1;
}

int myxp_copy_test( unsigned int length )
{
    if( length > xp_copy_bytes_threshold ) return 0;
    return -1;
}

myxp_error myxp_init(int v)
{
    return xp_init(v);
}

myxp_error myxp_set_cursor (int width, int height, int hot_x, int hot_y,
                                uint32_t *data, uint32_t rowbytes)
{
        return xp_set_cursor( width, height, hot_x, hot_y, data, rowbytes);
}

myxp_error myxp_hide_cursor()
{
    return xp_hide_cursor_async();
}

myxp_error myxp_show_cursor()
{
    return xp_show_cursor_async();
}

/* Fill HEIGHT rows of data starting at DST. Each row will have WIDTH
   bytes filled with the 32-bit pattern VALUE. Each row is DST-ROWBYTES
   wide in total. */

myxp_error myxp_fill_bytes (unsigned int width,
			       unsigned int height, uint32_t value,
			       void *dst, unsigned int dst_rowbytes)
{
	return xp_fill_bytes (width, height, value,
			                dst, dst_rowbytes);
}

/* Copy HEIGHT rows of bytes from SRC to DST. Each row will have WIDTH
   bytes copied. CONVERSION defines a possible conversion function to
   be applied to the data as it's being copied. Unless specified
   otherwise SRC and DST may overlap, and the right thing will happen. */

myxp_error myxp_copy_bytes (unsigned int width, unsigned int height,
			       int nmiddle, int conversion,
			       void *src, unsigned int src_rowbytes,
			       void *dst, unsigned int dst_rowbytes)
{
	return xp_copy_bytes (width, height, conversion,
			                src, src_rowbytes,
			                dst, dst_rowbytes);
}

/* Composite HEIGHT rows of bytes from SRC and DST to DST, possibly
   using VALUE to specify a constant parameter to the compositing
   function. Each row will have WIDTH bytes composited. */

myxp_error myxp_composite_bytes (unsigned int width, unsigned int height,
				    uint32_t value,
				    void *src, unsigned int src_rowbytes,
				    void *dst, unsigned int dst_rowbytes)
{
    if( width * height * 4 <= xp_composite_bytes_threshold )
        return -1;
        
	return xp_composite_bytes (width*4, height,
                                   XP_COMPOSITE_ARGB8888_A8_MASK_OVER_ARGB8888, value,
                                   src, src_rowbytes,
                                   dst, dst_rowbytes);
}
