#include <unistd.h>
#include <stdint.h>

typedef int myxp_error;

#define MYXP_COPY_BYTES XP_COPY_BYTES
#define MYXP_COPY_XRGB8888_ARGB8888 XP_COPY_XRGB8888_ARGB8888

#ifndef GOT_REAL_XP
enum xp_copy_bytes_conversion_type_enum {
    XP_COPY_BYTES               = 0,

    /* This has undefined results when source and destination overlap.
       All alpha values in the destination are set to 255 (opaque). */
    XP_COPY_XRGB8888_ARGB8888   = 1,
};
#endif

extern int myxp_use_xp_cursor;

extern int myxp_copy_test( unsigned int length );
extern int myxp_fill_test( unsigned int length );

extern myxp_error myxp_init(int v);
extern myxp_error myxp_set_cursor (int width, int height, int hot_x, int hot_y,
                                uint32_t *data, uint32_t rowbytes);

extern myxp_error myxp_hide_cursor();
extern myxp_error myxp_show_cursor();

/* Fill HEIGHT rows of data starting at DST. Each row will have WIDTH
   bytes filled with the 32-bit pattern VALUE. Each row is DST-ROWBYTES
   wide in total. */

extern myxp_error myxp_fill_bytes (unsigned int width,
                        unsigned int height, uint32_t value,
                        void *dst, unsigned int dst_rowbytes);

/* Copy HEIGHT rows of bytes from SRC to DST. Each row will have WIDTH
   bytes copied. CONVERSION defines a possible conversion function to
   be applied to the data as it's being copied. Unless specified
   otherwise SRC and DST may overlap, and the right thing will happen. */

extern myxp_error myxp_copy_bytes (unsigned int width, unsigned int height,
                        int nmiddle, int conversion,
                        void *src, unsigned int src_rowbytes,
                        void *dst, unsigned int dst_rowbytes);

/* Composite HEIGHT rows of bytes from SRC and DST to DST, possibly
   using VALUE to specify a constant parameter to the compositing
   function. Each row will have WIDTH bytes composited. */

extern myxp_error myxp_composite_bytes (unsigned int width, unsigned int height,
                        uint32_t value,
                        void *src, unsigned int src_rowbytes,
                        void *dst, unsigned int dst_rowbytes);

