/*
 * privatewinlist.c
 */

#include <Carbon/Carbon.h>
#include <QuickTime/QuickTime.h>
#include "insidecheck.h"
#include "privatewinlist.h"

static int	gotButtonDown=0, private_list_count=0;
int		need_window_flush=0, can_come_in_front=3; // start with default XDarwin behaviour
PrivateListRec	*private_list_start=NULL, *private_list_end=NULL;
Ptr     restoreState=NULL;

void Start_Whole_Screen_Mode()
{
    if( restoreState==NULL ) {
       short x=0, y=0;
       OSStatus err;
       err = BeginFullScreen( &restoreState, NULL, &x, &y, NULL, NULL, 0 );
       //restoreState = (Ptr)-1;
    }
}

void End_Whole_Screen_Mode()
{
    if( restoreState ) {
       OSStatus err;
       err = EndFullScreen( restoreState, NULL );
       restoreState = NULL;
    }
}


void AddToPrivateWindowList(AquaWindowRec *winRec)
{
    PrivateListRec *new;
    
    new = malloc(sizeof(PrivateListRec));

    if(private_list_start==NULL) {
        private_list_start=new;
        new->last=NULL;
        new->next=NULL;
        new->rw=winRec;
    } else {
        new->last=private_list_end;
        new->rw=winRec;
        new->next=NULL;
        private_list_end->next=new;
    }
    private_list_end=new;
//    if(verboseConsole)    
        printf("Added privateID %d (%#lx) to private window list\n",new->rw->privateID,new);
}

void RemoveFromPrivateWindowList(AquaWindowRec *winRec)
{
    PrivateListRec *aRec;
    
    aRec = private_list_start;
    
    while(aRec) {
        if(aRec->rw==winRec) {
            if(aRec==private_list_start) {
                private_list_start=aRec->next;
                if(private_list_start==NULL)
                    private_list_end=NULL;
                else
                    private_list_start->last=NULL;
            } else if(aRec==private_list_end) {
                private_list_end=aRec->last;
                private_list_end->next=NULL;
            } else {
                aRec->next->last=aRec->last;
                aRec->last->next=aRec->next;
            }
//            if(verboseConsole)
                printf("Removed privateID %d (%#lx) from private window list\n",aRec->rw->privateID,aRec);
            free(aRec);
            aRec = NULL;
            return;
        } else
            aRec = aRec->next;
    }
    printf("Failed to find privateID %d in private window list!!!\n",aRec->rw->privateID);
}

void *GetWinByHackID(int hackid)
{
    PrivateListRec *aRec;
    
    aRec = private_list_start;
    
    while(aRec) {
        if(aRec->rw->hackID==hackid) {
//            ErrorF("============== Got window with HACKID %d ==============\n",hackid);
            return aRec->rw;
        }
        aRec = aRec->next;
    }
    
    printf("Failed to get window with HackID %d !!!!!!!\n",hackid);
    return NULL;
}

void *GetWinByPrivateID(int privateid)
{
    PrivateListRec *aRec;
    
    aRec = private_list_start;
    
    while(aRec) {
        if(aRec->rw->privateID==privateid) {
//            ErrorF("============== Got window with PrivateID %d ==============\n",privateid);
            return aRec->rw;
        }
        aRec = aRec->next;
    }
    
    printf("Failed to get window with PrivateID %d !!!!!!!\n",privateid);
    return NULL;
}

void PrivateFlushWindows(void)
{
    PrivateListRec *aRec;
    
    aRec = private_list_start;
    
    //printf("Flushing windows %#lx\n",aRec);
    while(aRec) {
        AquaFlushWindow(aRec->rw);
        aRec = aRec->next;
    }
    need_window_flush = 0;
}
